﻿System.Gadget.settingsUI = "nastaveni.html";
function gEBI(id)
{
	return document.getElementById(id);
}
function velicina(t, jednotky)
{
	return (t.length ? t : "—") + "\u2009" + jednotky;
}

var intervalId = 0;
function nactiMesto()
{
	var mesto = System.Gadget.Settings.read("mesto") || "Praha";
	var den = ["dnes", "dnes", "zitra", "pozitri"][System.Gadget.Settings.read("den") || 0];
	gEBI("mesto").innerText = mesto;
	gEBI("vice").href = "http://www.in-pocasi.cz/gadget/vice.php?mesto=" + encodeURIComponent(mesto) + "&den=" + encodeURIComponent(den) + "&verze=1.0";

	if(intervalId) clearInterval(intervalId);
	intervalId = setInterval(nactiStav, 30 * 60 * 1000);
	nactiStav();
}

function nactiStav()
{
	var mesto = System.Gadget.Settings.read("mesto") || "Praha";
	var den = parseInt(System.Gadget.Settings.read("den") || 0);
	var vzhled = ["sada-1", "sada-2", "sada-3"][parseInt(System.Gadget.Settings.read("vzhled") || 0)];

	var xhr = new XMLHttpRequest();
	xhr.open("GET", "http://www.in-pocasi.cz/iphone/data.php?mesto=" + encodeURIComponent(mesto) + "&stanice=" + encodeURIComponent(mesto) + "&upozorneni=ano&rnd=" + Math.random(), true);
	xhr.onreadystatechange = function()
	{
		if(xhr.readyState != 4) return false;
    gEBI("pozor").style.display = "none";
    
		var lines = xhr.responseText.split(/\r?\n/);
    for(var i = 0; i < lines.length; i++)
    {
      if(!lines[i]) continue;
      var line = lines[i].split(/\s*\:\s+/);
      if(line.length < 2) continue;
      var param = line[1].split("|");
      switch(line[0])
      {
        case "now":
    			gEBI("prave-ted").innerText = velicina(param[1], "\u00B0C");
    			gEBI("vitr-rychlost").innerText = velicina(param[3], "m/s");
    			gEBI("vitr-smer").innerText = param[4];
          break;
        case "pozor":
          gEBI("pozor").href = param[0];
          gEBI("pozor").title = gEBI("pozor").firstChild.title = param[1];
          gEBI("pozor").style.display = "";
          break;
        default:
          if(den == 0)
          {
            if(line[0] == "0")
            {
              gEBI("teplota").innerText = velicina(param[0], "\u00B0C");
              gEBI("ikona").src = vzhled + "/58/" + param[2] + ".png";
              gEBI("ikona").style.display = param[2] ? "" : "none";
            }
            else if(line[0] == "1")
            {
              gEBI("teplota2").innerText = velicina(param[0], "\u00B0C");
              gEBI("ikona2").src = vzhled + "/58/" + param[2] + ".png";
              gEBI("ikona2").style.display = param[2] ? "" : "none";
            }
          }
          else
          {
            if(line[0].length == 1 && parseInt(line[0].substr(0, 1)) == den - 1)
            {
              gEBI("teplota").innerText = velicina(param[0], "\u00B0C");
              gEBI("ikona").src = vzhled + "/69/" + param[2] + ".png";
              gEBI("ikona").style.display = param[2] ? "" : "none";
            }
          }
      }
    }
    
		srovnejZobrazeni(den == 0);
	}
	xhr.send("");
}

function srovnejZobrazeni(dual)
{
	gEBI("mesto").style.fontSize = "";
	gEBI("mesto").style.top = "";
	gEBI("teplota").style.top = "";
  var c = "";

	if(gEBI("mesto").offsetWidth > 70)
	{
    if(gEBI("mesto").offsetHeight > 20)
    {
      gEBI("mesto").style.fontSize = "10px";
      if(gEBI("mesto").offsetHeight > 20)
      {
        gEBI("mesto").style.top = "-4px";
        gEBI("teplota").style.top = "24px";
      }
    }
    c = "big";
  }
  
  if(dual) c = "big dual";
  document.body.className = c;
}

srovnejZobrazeni(true);
nactiMesto();
